---
title: /v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}
slug: campaign-reporting-apis/9YLm-v2advertisersadvertiseridcampaignscampaignidspaad-groupsadgroupid
docTags: 
createdAt: 2026-03-25T10:57:30.256Z
---

{
  "id": "Jpes4EZnjZoVDrLLRYThM",
  "type": "api-oas-v2",
  "data": {
    "method": "PUT",
    "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}",
    "servers": [
      {
        "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}",
        "description": "Generated server url"
      }
    ],
    "name": "",
    "description": "<p>Updates one or multiple attributes of a SPA ad group.\nOnly the attributes to be updated need to be specified.</p>\n<p>The ad group can be only associated to publishers the user has access to, publishers being\nassociated to the advertiser of the ad group and publishers having a product feed\nin the market of the ad groups campaign.\nThe eligible values for <em>publisherId</em> can be retrieved from the API endpoint\n<a href=\"#/Advertiser-Informational/getPublishersGroupedByMarkets\" target=\"_blank\">GET /v2/advertisers/{advertiserId}/eligible/publisher-markets</a>.\nMake sure to pass the query string parameter <em>marketId</em> representing the market of\nthe ad groups campaign as well as <em>adGroupType</em> with value <em>SPA</em>.</p>\n<p>The ad group can only target sites available for the ad groups publisher and campaigns market.\nThe site must contain at least one SPA ad unit.\nFurthermore, the ad group can only target locations available in the site the ad group\nis targeting.\nThe eligible values for <em>targetingSiteIds</em> and <em>targetingLocations</em> can be retrieved from the\nAPI endpoint <a href=\"#/Advertiser-Informational/getEligibleSiteLocations\">GET /v2/advertisers/{advertiserId}/eligible/site-locations</a>.\nMake sure to pass the query string parameter <em>adGroupType</em> with value <em>SPA</em>.\nBy default, all eligible sites are targeted available at the time of the ad group\ncreation are targeted. The locations HOME_PAGE, CHECKOUT and EMAIL are not targeted by default.\nAll other available locations are targeted by default.</p>\n<p><strong>Rules:</strong></p>\n<ul>\n<li><em>name</em> of an ad group under a campaign must be unique.</li>\n<li><em>startDate</em> must be before <em>endDate</em>.</li>\n<li><em>startDate</em> must be a present or future date.</li>\n<li><em>startDate</em> can only be modified if the current start date is a future date.</li>\n<li><em>budget</em> must always be greater than equal to <em>budgetSpent</em>.</li>\n<li><em>dailyBudget</em> must always be less than or equal to <em>budget</em>.</li>\n<li><em>dailyBudget</em> must always be less than or equal to <em>monthBudget</em>.</li>\n<li><em>dailyBudget</em> must always be less than or equal to <em>weeklyBudget</em>.</li>\n<li><em>weeklyBudget</em> must always be less than or equal to <em>budget</em>.</li>\n<li><em>weeklyBudget</em> must always be less than or equal to <em>monthBudget</em>.</li>\n<li><em>monthlyBudget</em> must always be less than or equal to <em>budget</em>.</li>\n<li><em>dailySpendPacing</em> can only be <em>EVEN</em> whenever <em>dailyBudget</em> is set or <em>useDynamicBudget</em> is true.</li>\n</ul>\n<p><strong>Note:</strong></p>\n<ul>\n<li>In order to drop <em>endDate</em>, <em>dailyBudget</em>, <em>weeklyBudget</em> or <em>monthlyBudget</em> explicitly\nset these fields to <em>null</em> in the request body.</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "advertiserId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        },
        {
          "kind": "required",
          "name": "campaignId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        },
        {
          "kind": "required",
          "name": "adGroupId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        }
      ],
      "headerParameters": [],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "SpaAdGroupUpdateRequest",
          "schema": [
            {
              "name": "name",
              "kind": "optional",
              "type": "string",
              "description": "",
              "example": "",
              "minLength": 3,
              "maxLength": 200,
              "pattern": "^(?!\\s*$).+"
            },
            {
              "name": "startDate",
              "kind": "optional",
              "type": "string<date-time>",
              "description": "",
              "example": "",
              "format": "date-time"
            },
            {
              "name": "endDate",
              "kind": "optional",
              "type": "string<date-time>",
              "description": "",
              "example": "",
              "format": "date-time"
            },
            {
              "name": "budget",
              "kind": "optional",
              "type": "number",
              "description": "",
              "example": ""
            },
            {
              "name": "dailyBudget",
              "kind": "optional",
              "type": "number",
              "description": "",
              "example": ""
            },
            {
              "name": "weeklyBudget",
              "kind": "optional",
              "type": "number",
              "description": "",
              "example": ""
            },
            {
              "name": "monthlyBudget",
              "kind": "optional",
              "type": "number",
              "description": "",
              "example": ""
            },
            {
              "name": "useDynamicBudget",
              "kind": "optional",
              "type": "boolean",
              "description": "Whenever dynamic budget is activated daily limits are calculated in order that the remaining budget is evenly distributed over the ad group's lifetime.",
              "example": ""
            },
            {
              "name": "dailySpendPacing",
              "kind": "optional",
              "type": "string<ASAP | EVEN>",
              "description": "",
              "example": "",
              "enum": [
                "ASAP",
                "EVEN"
              ]
            },
            {
              "name": "status",
              "kind": "optional",
              "type": "string<ADVERTISED | ARCHIVED | PAUSED>",
              "description": "",
              "example": "",
              "enum": [
                "ADVERTISED",
                "ARCHIVED",
                "PAUSED"
              ]
            },
            {
              "name": "targetedSiteIds",
              "kind": "optional",
              "type": "array",
              "description": "",
              "example": "",
              "itemType": "integer",
              "customType": "integer[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "targetedLocations",
              "kind": "optional",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/AdGroupTargetLocation",
              "customType": "AdGroupTargetLocation[]",
              "schema": [
                {
                  "name": "location",
                  "kind": "optional",
                  "type": "string<CATEGORY_PAGE | SEARCH_PAGE | HOME_PAGE | PRODUCT_PAGE | CHECKOUT | MINI_SEARCH | EMAIL | EMAIL_ABANDONED_CART>",
                  "description": "",
                  "example": "",
                  "enum": [
                    "CATEGORY_PAGE",
                    "SEARCH_PAGE",
                    "HOME_PAGE",
                    "PRODUCT_PAGE",
                    "CHECKOUT",
                    "MINI_SEARCH",
                    "EMAIL",
                    "EMAIL_ABANDONED_CART"
                  ]
                },
                {
                  "name": "pagePosition",
                  "kind": "optional",
                  "type": "string<MAIN_GRID | CAROUSEL | BELOW_THE_FOLD | ABOVE_THE_FOLD | L1 | L2 | L3 | L4>",
                  "description": "",
                  "example": "",
                  "enum": [
                    "MAIN_GRID",
                    "CAROUSEL",
                    "BELOW_THE_FOLD",
                    "ABOVE_THE_FOLD",
                    "L1",
                    "L2",
                    "L3",
                    "L4"
                  ]
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/SpaAdGroupUpdateRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "SpaAdGroupResponse",
            "schema": [
              {
                "name": "id",
                "kind": "optional",
                "type": "integer<int32>",
                "description": "",
                "example": 0,
                "format": "int32"
              },
              {
                "name": "publisher",
                "kind": "optional",
                "type": "object",
                "description": "",
                "modelRef": "#/components/schemas/PublisherWithGlobalFloorPriceResponse",
                "customType": "PublisherWithGlobalFloorPriceResponse",
                "schema": [
                  {
                    "name": "id",
                    "kind": "optional",
                    "type": "integer<int32>",
                    "description": "",
                    "example": 0,
                    "format": "int32"
                  },
                  {
                    "name": "name",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "bidBelowGlobalFloorPrice",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "",
                    "example": ""
                  }
                ]
              },
              {
                "name": "name",
                "kind": "optional",
                "type": "string",
                "description": "",
                "example": ""
              },
              {
                "name": "type",
                "kind": "optional",
                "type": "string<DISPLAY | SPA | SPONSORED_BRAND>",
                "description": "",
                "example": "",
                "enum": [
                  "DISPLAY",
                  "SPA",
                  "SPONSORED_BRAND"
                ]
              },
              {
                "name": "status",
                "kind": "optional",
                "type": "string<ARCHIVED | EXPIRED | LIVE | PAUSED | SCHEDULED | WAITING | REJECTED>",
                "description": "",
                "example": "",
                "enum": [
                  "ARCHIVED",
                  "EXPIRED",
                  "LIVE",
                  "PAUSED",
                  "SCHEDULED",
                  "WAITING",
                  "REJECTED"
                ]
              },
              {
                "name": "budget",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "budgetSpent",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "dailyBudget",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "weeklyBudget",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "monthlyBudget",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "useDynamicBudget",
                "kind": "optional",
                "type": "boolean",
                "description": "Whenever dynamic budget is activated daily limits are calculated in order that the remaining budget is evenly distributed over the ad group's lifetime.",
                "example": ""
              },
              {
                "name": "dailySpendPacing",
                "kind": "optional",
                "type": "string<ASAP | EVEN>",
                "description": "",
                "example": "",
                "enum": [
                  "ASAP",
                  "EVEN"
                ]
              },
              {
                "name": "spendVelocity",
                "kind": "optional",
                "type": "number<double>",
                "description": "The pacing of the ad group measures budget efficiency over time, where a value of 1.0 reflects ideal spend considering temporal progress of the ad group, less than 1.0 underspending, and more than 1.0 overspending. The value is not set whenever the ad group has no end date.",
                "example": "",
                "format": "double"
              },
              {
                "name": "startDate",
                "kind": "optional",
                "type": "string<date-time>",
                "description": "",
                "example": "",
                "format": "date-time"
              },
              {
                "name": "endDate",
                "kind": "optional",
                "type": "string<date-time>",
                "description": "",
                "example": "",
                "format": "date-time"
              },
              {
                "name": "targetedSiteIds",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "integer",
                "customType": "integer[]",
                "itemExample": "",
                "itemDefault": ""
              },
              {
                "name": "targetedLocations",
                "kind": "optional",
                "type": "array",
                "description": "",
                "modelRef": "#/components/schemas/AdGroupTargetLocation",
                "customType": "AdGroupTargetLocation[]",
                "schema": [
                  {
                    "name": "location",
                    "kind": "optional",
                    "type": "string<CATEGORY_PAGE | SEARCH_PAGE | HOME_PAGE | PRODUCT_PAGE | CHECKOUT | MINI_SEARCH | EMAIL | EMAIL_ABANDONED_CART>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "CATEGORY_PAGE",
                      "SEARCH_PAGE",
                      "HOME_PAGE",
                      "PRODUCT_PAGE",
                      "CHECKOUT",
                      "MINI_SEARCH",
                      "EMAIL",
                      "EMAIL_ABANDONED_CART"
                    ]
                  },
                  {
                    "name": "pagePosition",
                    "kind": "optional",
                    "type": "string<MAIN_GRID | CAROUSEL | BELOW_THE_FOLD | ABOVE_THE_FOLD | L1 | L2 | L3 | L4>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "MAIN_GRID",
                      "CAROUSEL",
                      "BELOW_THE_FOLD",
                      "ABOVE_THE_FOLD",
                      "L1",
                      "L2",
                      "L3",
                      "L4"
                    ]
                  }
                ]
              },
              {
                "name": "advertised",
                "kind": "optional",
                "type": "boolean",
                "description": "",
                "example": ""
              },
              {
                "name": "globalFloorPrice",
                "kind": "optional",
                "type": "number",
                "description": "",
                "example": ""
              },
              {
                "name": "modifiedAt",
                "kind": "optional",
                "type": "string<date-time>",
                "description": "",
                "example": "",
                "format": "date-time"
              }
            ],
            "modelRef": "#/components/schemas/SpaAdGroupResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "404",
        "description": "Not Found",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "422",
        "description": "Unprocessable Entity",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "nXJEyDyefrNgH0rVgmUPQ",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request PUT \\\n     --url https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId} \\\n     --header 'accept: application/json'"
        },
        {
          "id": "EntpFKwrw1RGGRnDl4pbE",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'PUT',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "cFATO2ehb-BJVyZWK8vfD",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Put.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "SIhs4OJaaevra7vqdjcnq",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"PUT\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "nXJEyDyefrNgH0rVgmUPQ"
    },
    "results": {
      "languages": [
        {
          "id": "dotqQ11ln7VPtf4YxaUyC",
          "language": "200",
          "code": "// OK\n{\n  \"id\": \"\",\n  \"publisher\": {\n    \"id\": \"\",\n    \"name\": \"\",\n    \"bidBelowGlobalFloorPrice\": false\n  },\n  \"name\": \"\",\n  \"type\": \"\",\n  \"status\": \"\",\n  \"budget\": 0,\n  \"budgetSpent\": 0,\n  \"dailyBudget\": 0,\n  \"weeklyBudget\": 0,\n  \"monthlyBudget\": 0,\n  \"useDynamicBudget\": false,\n  \"dailySpendPacing\": \"\",\n  \"spendVelocity\": \"\",\n  \"startDate\": \"\",\n  \"endDate\": \"\",\n  \"targetedSiteIds\": [\n    0\n  ],\n  \"targetedLocations\": [\n    {\n      \"location\": \"\",\n      \"pagePosition\": \"\"\n    }\n  ],\n  \"advertised\": false,\n  \"globalFloorPrice\": 0,\n  \"modifiedAt\": \"\"\n}"
        },
        {
          "id": "ZMRAy6zbB_l1l5J7x5oHH",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "kzoIqoiK3RWuuy6TtE1DX",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "2YqgJbHVnaszRJW0-Jml2",
          "language": "404",
          "code": "// Not Found\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        },
        {
          "id": "mj6nfxH4TbCx5y5cBSYjN",
          "language": "422",
          "code": "// Unprocessable Entity\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        }
      ],
      "selectedLanguageId": "dotqQ11ln7VPtf4YxaUyC"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}